Page MenuHomePhabricator

Homepage: help module
Closed, ResolvedPublic

Description

This is a task for building one of the modules in the newcomer homepage: the help module.

Main audience: Newcomers who want to learn more about Wikipedia editing on their own.

Primary targeted persona(s): Jae-Hee (Social Changer); Mina (Box Checker)

Secondary persona(s): Helena (Joiner-Inner); Yankov (Knowledge Sharer)

Goal/rationale for this module: Provide help that we know many newcomers seek directly. The initial EditorJourney report told us that between 30% and 40% of newcomers read a Help or Policy page on their first day. We also see from initial usage of the help panel that about half of newcomers who open up the help panel click one of its links. We believe that this is evidence that although many newcomers can find help materials on their own, we should continue to make it easier for them.

Invision mockups: https://wikimedia.invisionapp.com/share/KUQV2QDJ8A7#/screens/350626962

Summary: In short, the proposal here is to put the contents of the help panel directly onto the page, as opposed to in the help panel widget. This gives those contents more affordance in the context of the homepage, which is a page where we expect newcomers to be specifically looking for help. This version of the help panel would be considered a distinct "context" for the purposes of varying links by context (T211117).

Specifications for initial version

  • General
    • This module should be present for all newcomers.
    • Though this module is similar to the help panel, there should be no "X" to dismiss it, and no cog to disable it or learn more.
    • Though the help panel has a search component, this initial version will not have search.
  • Copy and links
    • Title: "Get help with editing"
    • Header: "Top help pages about editing"
    • Next: Bulleted list of the five help links chosen by the community. These should be the same as those in the help panel.
    • Next: "View more help articles", which links to Help:Contents, just like in the help panel.
    • Next: A button labeled "Ask the help desk" (see "Asking the help desk" section for behavior)
    • Note: the "Your recent questions" section is included in the mockups, but is not part of the specifications for the initial version. See T218841 for development of this capability.
  • "Ask the help desk"
    • When users with no Javascript click the button, they should be taken directly to the help desk.
    • When users with Javascript click the button, a modal should open with the same essential behavior as the modal for the mentorship module in T216631, but with different copy.
    • Screen 1: asking the question and email configuration
      • Title: "Ask the help desk"
      • Contents: this should be the exact same words, links, and business rules that exist in the help panel: "When you submit a question...", followed by the email address options, followed by the question box.
      • There should not be an option to "Include page title with my question", since that is not applicable on the homepage.
    • This screen should have a "Post my question" button that is inactive unless there is text in the question box.
    • This screen should have a "Cancel" button to close the modal.
    • Screen 2: success
      • Title: "Ask the help desk"
      • Contents: this should be the exact same words, links, and business rules that exist in the help panel: "Your question has been posted!", with checkmark, sentences according to email status, congratulations on first edit (if applicable), and link to view the question on the help desk.
      • This screen should have a "Done" button.
    • On the help desk
      • New questions should be posted to the help desk in the same way as the help panel, with the following two exceptions.
      • The header should read like, "Help module question from user homepage (23:03, 20 February 2019)". This header should not contain a link at all.
      • These questions should be saved with the edit tag, "Help module question".

Potential future specifications, listed for planning purposes

  • Add the "Your recent questions" capability to easily link users to their questions and responses. See T218841 for this capability.
  • Add help search. See the discussion on this task for ideas and options.
  • Perhaps we could encourage the user to view the help desk before asking a question, which might give them more confidence when asking. This is similar in concept to the link that will be in the mentorship module that reads, "View your mentor's conversations with other users."
  • Instead of having users ask the question in a modal, maybe there is a way to take them to the help desk and use a GuidedTour to take them through posting their question.
  • In the modal for asking a question, we may want to illustrate to newcomers how to check their notifications to receive their response, perhaps by indicating it with a GuidedTour addition.
  • Personalize content based on the user's needs from the welcome survey (e.g. if they created their account to make a new article, this module could contain resources for creating a new article).

Note for the future: one of @kostajh's ideas was to make the newcomer homepage into a panel that is present whenever the user wants to open it. The fact that this task currently wants the help panel to be embedded in the homepage is another reason why a ubiquitous homepage panel would be valuable -- we already have a help panel, and those concepts could be combined.


Below are @Etonkovidova's testing results archived from an earlier description on this task.

  • It should not have "X" to dismiss it. It is not dismissable.
  • It should not have a cog, and does not need either of the links found under the cog ("Disable this tool", "More about this feature")
  • It should contain the question-asking dialogue and process just like the help panel.
  • It should include the same options and logic around adding or changing an email address.
  • It should not have the option to "Include page title with my question".
  • When a question is posted to the help desk, the header should read like, "Help module question from user homepage (23:03, 20 February 2019)". This header should not contain a link at all.
  • The buttons for navigating between screens on the help panel work the same, except the button labeled "Done" on the screen after asking a question should return the help panel to its original, neutral state.
  • For non-Javascript users, instead of the question-asking field, there should just be a link that says "Post your question to the Community Help Desk", with that whole phrase being a link to the help desk. There should not be a "Continue" button for those users.
  • These questions should be saved with the edit tag, "Help module question".

Details

Related Gerrit Patches:
mediawiki/extensions/GrowthExperiments : masterHelp module: Adjust dialog title, header and subheader wording
mediawiki/extensions/GrowthExperiments : masterHomepage Help: Add subheader
mediawiki/extensions/GrowthExperiments : masterHelp module: Set tag and fix section heading
mediawiki/extensions/GrowthExperiments : masterUpdate helppanel schema version to accept editor=homepage
mediawiki/extensions/GrowthExperiments : masterHomepage: Add Help module

Related Objects

Event Timeline

There are a very large number of changes, so older changes are hidden. Show Older Changes

I'm specifically thinking of the feature that lists questions the user asked.

If we do that, it would be helpful to see a design. While I can easily picture what it will look like with 1 question, what if a user asks 10+ questions? Will we implement a pager to navigate the list of questions? If not, what's the business logic for hiding the links to those questions? Also, as non Flow help desk content gets archived over time, the links won't be valid, so we would need to think about how to handle that as well.

Another question is whether questions coming from this module should have a different edit tag than from the help panel

Yes, that would make sense. What should the edit tag be called?

and different automatic headers when posted to the help desk

I have implemented that per the task description, e.g. Help panel question from user homepage (23:03, 20 February 2019)

@kostajh

  • Feature that lists questions: like I wrote in T216631, I think we should just list the three most recent questions, which gets us away from needing to handle paging or anything like that. The most help panel questions that anyone has ever asked is two. But this does not solve the issue of broken links from archiving. Can you think of any way to address this? I don't suppose there is some way to get to link to the archived content, or to detect that a question has been archived and gray it out in the list, or something like that?
  • Edit tag: this should be Help module question.
  • Automatic headers: now that we are tracking the module separate from the panel, and potentially giving it different functionality, I think it would be wise to give it a different header. I think the difference should just be "Help module..." instead of "Help panel..." It's possible that the translators translate it the same way, but at least they'll have the option.

I'll make the changes from the latter two bullets in the description, as we continue to discuss the first bullet.

MMiller_WMF updated the task description. (Show Details)Mar 6 2019, 1:16 AM
Cntlsn updated the task description. (Show Details)Mar 6 2019, 4:58 PM

@kostajh I have updated the link to the invision prototype in the task description

Change 493070 merged by jenkins-bot:
[mediawiki/extensions/GrowthExperiments@master] Homepage: Add Help module

https://gerrit.wikimedia.org/r/493070

Change 494932 had a related patch set uploaded (by Sbisson; owner: Sbisson):
[mediawiki/extensions/GrowthExperiments@master] Update helppanel schema version to accept editor=homepage

https://gerrit.wikimedia.org/r/494932

Change 494932 merged by jenkins-bot:
[mediawiki/extensions/GrowthExperiments@master] Update helppanel schema version to accept editor=homepage

https://gerrit.wikimedia.org/r/494932

Etonkovidova updated the task description. (Show Details)Mar 8 2019, 11:18 PM
Etonkovidova added a comment.EditedMar 8 2019, 11:29 PM

The Help module is present on the Homepage (betalabs and testwiki).

Here are my comments on the specs marked with :
(1)

It should contain the question-asking dialogue and process just like the help panel.

Has it been decided to go for the modal solution? The updated mocks (at least from what I've seen) do not show it clearly.

(2)

When a question is posted to the help desk, the header should read like, "Help module question from user homepage (23:03, 20 February 2019)". This header should not contain a link at all.

"Help module" is an internal term; it might be not understood well by the user. Right now the header looks like the following - no capitalization of the page title.

(3)

For non-Javascript users, instead of the question-asking field, there should just be a link that says "Post your question to the Community Help Desk", with that whole phrase being a link to the help desk. There should not be a "Continue" button for those users.

Presently, non-Javascript version will have the same Help desk module layout and clicking on 'Ask help desk' will redirect to the top of Wikipedia:Help desk page.

(4)

These questions should be saved with the edit tag, "Help module question".

Presently, Tag: Help panel question is added to questions coming from Help panel question from user homepage.

Open questions:

(1) There are two reference in the discussion above to the label "Ask Help Desk" and "Ask the Help Desk" - the current implementation is "Ask help desk" - 'help desk' is not capitalized. Should we change it?

(2) There is no space between the bullet points and "View more help articles"

nettrom_WMF added a comment.EditedMar 11 2019, 6:01 PM

What's the current state of search in this module? I went back and read through the comment above about the result of the deep dive, but didn't see much about it since then (and it's not present in the mockup). Curious about that, as it'll inform the measurement specification.

Restricted Application added a subscriber: Liuxinyu970226. · View Herald TranscriptMar 11 2019, 6:01 PM

@nettrom_WMF we discussed this in T215986#4970275. IIRC the reasoning was as you described – it somewhat duplicates existing search, and we didn't have a clear spec for how the search should be implemented in the UI.

@nettrom_WMF we discussed this in T215986#4970275. IIRC the reasoning was as you described – it somewhat duplicates existing search, and we didn't have a clear spec for how the search should be implemented in the UI.

Apologies for editing my comment as it now no longer mentions the duplication issue, I was going back and reading the previous activity and found the comment you refer to. I think we should look at the search usage numbers from the Help Panel and then decide whether to prioritize figuring out the search implementation, I'll bring that up in a future standup.

Access to search is very complicated. If you want to search something in Help namespace, you have the following choices:

  • know that you have to user the prefix Help:
  • go to Special:Search to have access to the options
  • search a given content on the generic search field, like "add an image" and then discover that you can select namespaces on the results page.

If we have a high number of uses of the search field in the Help panel, we should definitely have a search field on the Homepage as well. That's if we rely on data, because common sense would say that if we create a basecamp for newcomers, they should go to where they need to go from there. And help pages seem to be the place to go.

I'm not sure I get exactly all the technicalities that @Trizek-WMF highlighted in the previous comment, but I got an idea for the help search area.
Would something like the mockup below make it more understandable and "educational"?

I'm not sure I get exactly all the technicalities that @Trizek-WMF highlighted in the previous comment, but I got an idea for the help search area.

We don't plan to provide a search field on the Homepage (per T215986#4970275). To search for help, users will have to click on the "view more help contents". That link goes to a page, not a search field. To access a search function that only targets help contents, it would be easier to edit an article that using the Homepage.

If you try to search for help contents on the current search field you have on any wiki (not the Help panel one but the one located top-right), you will get zero Help: results. That search engine is calibrated to only give you articles. You need to know the tricks I was mentioning earlier to access help contents using the global search engine.

Would something like the mockup below make it more understandable and "educational"?

The existing label above the field is clear enough IMO: "searching help".
Add the prefix is a bit redundant (or confusing): you don't really know what it is standing for. Beginners I've been working with are not aware of namespaces and add it there without any more explanation is strange.

Anyway, my suggestion is actually very simple: implement the search field on the Home page as it is on the Help panel now.
Users are familiar with it since they have it any time they edit (consistency across tools and interfaces). Plus it avoids the search pitfall, where you need to know some tricks to manage to search something on the Help namespace.

@Cntlsn and @Trizek-WMF, I still have the questions from T215986#4969525 . Also, keep in mind how narrow this module is – the help panel on desktop is 500 pixels (and includes excerpts), while this module is 240 pixels. That's close to the width of the desktop search bar (285 pixels) but the desktop search bar doesn't include excerpts.

Where should the search results appear? Should it be a box populated with suggestions (like the main search on e.g. en.wikipedia.org)? e.g.


Should the results display as in the help panel? If so, should that push other content down, or should there be an overlay?

Results displayed in the help panel give more abstract. I think it is better than a simple title.

@Cntlsn and @Trizek-WMF, I still have the questions from T215986#4969525 . Also, keep in mind how narrow this module is – the help panel on desktop is 500 pixels (and includes excerpts), while this module is 240 pixels. That's close to the width of the desktop search bar (285 pixels) but the desktop search bar doesn't include excerpts.

I'm not sure to understand: you mean that we don't implement the search bar for help because of that limited width? Or because on how the results would be displayed? I don't remember how it is supposed to look like, with the other modules.

Are we limited to that width for good?

This comment was removed by Trizek-WMF.

you mean that we don't implement the search bar for help because of that limited width? Or because on how the results would be displayed?

Yeah, I'm just saying we should keep in mind that it's going to be quite narrow, so there will be a limit on how many results appear, how quickly someone can scan the search results, etc. Maybe it's not a problem, but IMO it's not going to be as usable as the desktop help panel search if we stay with this width. Here's a screenshot of the desktop help panel search reduced to 240px width:

I don't remember how it is supposed to look like, with the other modules. Are we limited to that width for good?

I defer to @Cntlsn on that, but as far as I know the help module is meant to be one of the modules that appears in a sidebar, and is of secondary importance to other content that appears on the page.

Change 495897 had a related patch set uploaded (by Kosta Harlan; owner: Kosta Harlan):
[mediawiki/extensions/GrowthExperiments@master] Help module: Set tag and fix section heading

https://gerrit.wikimedia.org/r/495897

Discussed the mockups with @Cntlsn and we noticed that the current mockups does not show the flow that we want to implement for the initial version, in which there is no box to type a question -- but rather a button to open the modal. He will make updated mockups.

InVision mockup updated as per latest specification:

  • No question-asking dialogue as in the Help panel
  • "Ask help desk" button will send user to Help desk

@MMiller_WMF shall the task description be updated as well?

Change 496086 had a related patch set uploaded (by Kosta Harlan; owner: Kosta Harlan):
[mediawiki/extensions/GrowthExperiments@master] Homepage Help: Add subheader

https://gerrit.wikimedia.org/r/496086

kostajh added a comment.EditedMar 13 2019, 2:10 AM

No question-asking dialogue as in the Help panel

  1. Just to clarify @MMiller_WMF and @Cntlsn, is the current behavior on https://en.wikipedia.beta.wmflabs.org/wiki/Special:Homepage correct? Clicking the "Ask help desk" button opens a modal where you can input a question and post it to the help desk.

For non-Javascript users, instead of the question-asking field, there should just be a link that says "Post your question to the Community Help Desk", with that whole phrase being a link to the help desk. There should not be a "Continue" button for those users.

  1. @MMiller_WMF Is it OK if the button is identical for JS and no JS users, so in both instances it's "Ask help desk" ?

When a question is posted to the help desk, the header should read like, "Help module question from user homepage (23:03, 20 February 2019)". This header should not contain a link at all.

  1. @Etonkovidova This is done.

These questions should be saved with the edit tag, "Help module question".

  1. @Etonkovidova This is done.

  1. @Cntlsn I think you and Stephane were talking about "Inspect mode" in Invision. Can you share with me the styles we should apply?

  1. @Cntlsn @MMiller_WMF the mockup has "Find or Ask for Help" as the header, while impact module's is "Your impact". It seems to me that we should be consistent with capitalizing in the header, so either "Your Impact" and "Find or Ask for Help", or, "Your impact" and "Find or ask for help" – I favor the latter, but let me know what you want implemented.
Cntlsn added a comment.EditedMar 13 2019, 11:17 AM

@kostajh just sent you an invite to zeplin, let me know if you need any help with it!

the mockup has "Find or Ask for Help" as the header, while impact module's is "Your impact". It seems to me that we should be consistent with capitalizing in the header, so either "Your Impact" and "Find or Ask for Help", or, "Your impact" and "Find or ask for help" – I favor the latter, but let me know what you want implemented.

Good point, thanks!
I generally like capitalized, but since we went for non-capitalized from the beginning I normalized and updated the title for the help module in the mockup.

Change 495897 merged by jenkins-bot:
[mediawiki/extensions/GrowthExperiments@master] Help module: Set tag and fix section heading

https://gerrit.wikimedia.org/r/495897

Change 496086 merged by jenkins-bot:
[mediawiki/extensions/GrowthExperiments@master] Homepage Help: Add subheader

https://gerrit.wikimedia.org/r/496086

When a question is posted to the help desk, the header should read like, "Help module question from user homepage (23:03, 20 February 2019)". This header should not contain a link at all.

  1. @Etonkovidova This is done.

These questions should be saved with the edit tag, "Help module question".

  1. @Etonkovidova This is done.

Re-checked and removed the red exclamation points ().

@MMiller_WMF moving into your column pending a review of questions 1 and 2 in T215986#5019866

MMiller_WMF updated the task description. (Show Details)Mar 19 2019, 4:13 AM
MMiller_WMF updated the task description. (Show Details)Mar 19 2019, 4:29 AM

@kostajh @Cntlsn @Etonkovidova -- I spent time trying to reorganize and sort out the specifications on this task. I'm sorry this one has been confusing -- my mistake was to take the shortcut of saying that it's like the help panel, but with a list of exceptions. Listing the specifications out like in the other modules would have helped.

I added the full set of specifications as a new section under the original task description, so that we don't lose anything important and can see what changed. But if we want the new content to replace the old, let me know and I will do it.

Here are some of the things I've specifically tried to address:

  • Clarified that there is no search in the initial version.
  • Clarified that the call to action opens a modal, and the behavior for no Javascript users.
  • Changed some of the copy -- I'm not sure where/when the copy changed over the last few weeks, so I wrote down exactly what it should be.
  • Added the capability to see your existing questions as a requirement, along with business rules.

Here are action items:

  • @Cntlsn to make the mockups match these latest specifications.
  • @Cntlsn to include designs for the "View your recent questions"
  • @Trizek-WMF -- could you please read the "View your recent questions" section in the task description, and give us any ideas for how to deal with links that don't work anymore because pages have been archived or sections deleted? How does this work elsewhere in the wikis?
  • @kostajh -- does it matter or help when the text in the module is identical to that in the help panel or identical to that in the mentorship module? Or will these be separate messages with separate translations?
  • @kostajh and @Cntlsn -- we should probably talk through this all together to make sure we are in agreement. I will bring it up in stand up.
Cntlsn updated the task description. (Show Details)Mar 19 2019, 10:25 AM

invision mockups updated

  • @Trizek-WMF -- could you please read the "View your recent questions" section in the task description, and give us any ideas for how to deal with links that don't work anymore because pages have been archived or sections deleted? How does this work elsewhere in the wikis?

"Your recent questions"
When the newcomer has asked a question, a new header should appear under the "Ask the help desk" button that reads, "Your recent questions".
Listed under that header should be the most recent three questions that the user has asked via the help module.

This is only doable if we have one page per question. For instance a StructuredDiscussion Topic. On unstructured wikitext talkpages where wections are piled piled on top of the other, I'm pretty sure it will be impossible to monitor questions from a given user if some of them are edited, or some other sections are added between the different requests (new discussion, sub-section of an existing discussion, etc. )

They should be listed with a snippet from the beginning of the text with an ellipses. So if the user's question was, "hello Cloud atlas, how do i add a photo to an article?", the snippet might read, >"hello Cloud atlas, how do i a..." We could also experiment with listing the date of the question alongside.
If a link to a question no longer works, because the page has been archived or the question has been deleted/reverted, the snippet of the question should be greyed out and italicized. This is not >an ideal business rule, and hopefully we can come up with a better idea.

How people archive pages (some other cases may exist):

  • Every page is designed to be used for a given period of time (daily VP on fr.wp, monthly Help desk on ko.wp...). Links are not broken, but the structure of the page can still be impacted.
  • A bot will archive unanswered questions to a sub page (without any follow-up link) after a couple of days (I've noticed it is around 30 days most of time).
  • Rough archiving by deletion. People rely on History to find things back.
  • No archive at all on low-trafic pages.
  • StructuredDiscussion is a particular case. It auto-archive, but since every topic is a page, it is really easy to visit back a linked conversation, even after years. You greying feature would be doable using the "resolve a topic" option.

I think it would be easier to force a format than create a system that works for cases. I don't see any reasonable solution other than forcing people to adopt a format, format they may not convinced by.

does it matter or help when the text in the module is identical to that in the help panel or identical to that in the mentorship module? Or will these be separate messages with separate translations?

As far as I know, it's OK for them to be reused. After the mentorship module is merged, we could update the qqq text for each string to make it clear that it can also appear in the help and mentorship modules on Special:Homepage.

kostajh added a comment.EditedMar 19 2019, 2:54 PM

When the newcomer has asked a question, a new header should appear under the "Ask the help desk" button that reads, "Your recent questions".
Listed under that header should be the most recent three questions that the user has asked via the help module.

On unstructured wikitext talkpages where wections are piled piled on top of the other, I'm pretty sure it will be impossible to monitor questions from a given user if some of them are edited, or some other sections are added between the different requests (new discussion, sub-section of an existing discussion, etc. )

A couple of thoughts:

  1. When the user posts a question, the API gives us the URL with the header which should at that time be valid. When we get that, we could store this value in the database
  2. When the user loads Special:Homepage, we load the URLs (potentially stale) that we got back from the API and have stored in the DB
  3. For users with JavaScript, we'd then update these links in the background by 1) loading "help module question" tagged edits made by the user, 2) checking the help desk to see if those questions exist on the page content. We could also try using the search API to find the current location of those questions, example search for question content. If they can't be found, then either update the links to go to the revision when the user made their edit (not especially helpful since they won't be able to see replies) or remove them?

@kostajh and I discussed the "Your recent questions" feature and decided that we should break it off into separate Phab tasks, and also not require it for the initial version (though it is great if we do include it). I'll make those tasks.

Having re-solidified these specifications, I am now putting this back in Ready for Development.

Change 498486 had a related patch set uploaded (by Kosta Harlan; owner: Kosta Harlan):
[mediawiki/extensions/GrowthExperiments@master] Help module: Adjust dialog title, header and subheader wording

https://gerrit.wikimedia.org/r/498486

Change 498486 merged by jenkins-bot:
[mediawiki/extensions/GrowthExperiments@master] Help module: Adjust dialog title, header and subheader wording

https://gerrit.wikimedia.org/r/498486

Etonkovidova updated the task description. (Show Details)Apr 2 2019, 9:48 PM
Etonkovidova moved this task from QA to Design Review on the Growth-Team (Current Sprint) board.EditedApr 2 2019, 10:40 PM

Re-tested in testwiki (wmf.24) - all look and work according to the spec.

@MMiller_WMF - one question:

This module should be present for all newcomers.

  • Help module is not default for newcomers in betalabs and testwiki.
  • Are we still planning to have 50/50 split of new users with Home page enabled?

@Cntlsn - for your review.

The following minor discrepancies between Help panel and Help module are ok?

  • bullet lists are different
  • 'Post my question' is in the different place
  • 'Ask the help desk' for Help module vs 'Ask a question' for Help panel
  • Cancel button on Help module and X button on Help panel
Help moduleHelp panel

@Etonkovidova @MMiller_WMF
From a UX point of view the Help panel features a better design treatment, the position of the actions is more understandable and follows consolidated UI patterns.
But, the modal featured in the Help module process is actually the one that respects the OOUI specifications, and specifically it's based on the "Process dialog (medium)" specifications.

This all looks good to me! I will leave this in my column until we have tested it in our target wikis in production.

This has been in production for three weeks, and so far is working fine. But I'm going to leave it open because no newcomers have attempted to ask a question via the help module. I'd like to see that happen before closing the task.

MMiller_WMF closed this task as Resolved.Jun 19 2019, 10:34 PM

The help module has been functioning well in production for weeks.